package com.hisschemoller 
{
	import com.hisschemoller.controller.AddSoundCommand;
	import com.hisschemoller.controller.GeneratorCommand;
	import com.hisschemoller.controller.Mp3LoadCommand;
	import com.hisschemoller.controller.Mp3SelectCommand;
	import com.hisschemoller.controller.ReverseSampleCommand;
	import com.hisschemoller.controller.StartupCommand;
	
	import org.puremvc.as3.interfaces.IFacade;
	import org.puremvc.as3.patterns.facade.Facade;
	import org.puremvc.as3.patterns.observer.Notification;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class AppFacade extends Facade implements IFacade 
	{
		// Notification name constants
		public static const STARTUP : String = "startup";
		public static const MP3_SELECT : String = "mp3Select";
		public static const MP3_LOAD : String = "mp3Load";
		public static const ADD_SOUND : String = "addSound";
		// public static const CLEAR_SAMPLE : String = "clearSample";
		public static const ADD_GENERATOR : String = "addGenerator";
		public static const REMOVE_GENERATOR : String = "removeGenerator";
		public static const REVERSE_SAMPLE : String = "reverseSample";

		/**
		 * Singleton ApplicationFacade Factory Method
		 */
		public static function getInstance() : AppFacade 
		{
			if(instance == null) instance = new AppFacade();
			
			return instance as AppFacade;
		}

		/**
		 * Broadcast the STARTUP Notification
		 */
		public function startup(app : Object) : void 
		{
			notifyObservers(new Notification(AppFacade.STARTUP, app));
		}

		/**
		 * Register Commands with the Controller
		 */
		override protected function initializeController() : void 
		{
			super.initializeController();
			
			registerCommand(AppFacade.STARTUP, StartupCommand);
			registerCommand(AppFacade.MP3_SELECT, Mp3SelectCommand);
			registerCommand(AppFacade.MP3_LOAD, Mp3LoadCommand);
			registerCommand(AppFacade.ADD_SOUND, AddSoundCommand);
			registerCommand(AppFacade.ADD_GENERATOR, GeneratorCommand);
			registerCommand(AppFacade.REMOVE_GENERATOR, GeneratorCommand);
			registerCommand(AppFacade.REVERSE_SAMPLE, ReverseSampleCommand);
		}
	}
}
