package com.hisschemoller.controller 
{
	import com.hisschemoller.AppFacade;
	import com.hisschemoller.utils.sound.SoundLoader;
	import com.hisschemoller.utils.sound.SoundLoaderEvent;
	import com.hisschemoller.utils.sound.SoundVO;
	
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Oct 2, 2009
	 */
	public class Mp3LoadCommand extends SimpleCommand implements ICommand 
	{
		private var mSoundLoader : SoundLoader;

		override public function execute(note : INotification) : void
		{
			var soundVO : SoundVO = new SoundVO();
			soundVO.url = note.getBody() as String;
			
			mSoundLoader = SoundLoader.getInstance();
			mSoundLoader.addEventListener(SoundLoaderEvent._EVENT, handleSoundLoaderEvent);
			mSoundLoader.loadSound(soundVO);
		}

		/**
		 * handle events from the SoundLoader
		 */
		private function handleSoundLoaderEvent(event : SoundLoaderEvent) : void 
		{
			switch(event.subtype)
			{
				case SoundLoaderEvent.COMPLETE:
					facade.sendNotification(AppFacade.ADD_SOUND, event.soundVO);
				case SoundLoaderEvent.ERROR:
				case SoundLoaderEvent.ALL_LOADED:
					mSoundLoader.removeEventListener(SoundLoaderEvent._EVENT, handleSoundLoaderEvent);
					break;
			}
		}
	}
}
