package com.hisschemoller.controller 
{
	import com.hisschemoller.AppFacade;
	import com.hisschemoller.utils.sound.SoundVO;
	
	import org.audiofx.mp3.MP3FileReferenceLoader;
	import org.audiofx.mp3.MP3SoundEvent;
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.FileFilter;
	import flash.net.FileReference;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Oct 2, 2009
	 */
	public class Mp3SelectCommand extends SimpleCommand implements ICommand 
	{
		private var _mp3Loader : MP3FileReferenceLoader;
		private var _fileReference : FileReference;
		
		override public function execute(note : INotification) : void
		{
			_fileReference = new FileReference();
			_fileReference.addEventListener(Event.SELECT, handleFileReferenceSelect);
			_fileReference.addEventListener(Event.CANCEL, handleNoSelection);
			_fileReference.addEventListener(IOErrorEvent.IO_ERROR, handleNoSelection);
			_fileReference.browse([ new FileFilter("MP3 Files", "*.mp3") ]);
			
			_mp3Loader = new MP3FileReferenceLoader();
			_mp3Loader.addEventListener(MP3SoundEvent.COMPLETE, handleMp3LoaderComplete);
		}

		/**
		 * A local file is selected, convert the FileReference.data byteArray to a Sound object
		 */
		private function handleFileReferenceSelect(event : Event) : void
		{
			_mp3Loader.getSound(_fileReference);
		}
		
		/**
		 * 
		 */
		private function handleNoSelection(inEvent : Event) : void
		{
			removeListeners();
		}

		/**
		 * @param inEvent : MP3SoundEvent width Sound object as property sound.
		 */
		private function handleMp3LoaderComplete(event : MP3SoundEvent) : void
		{
			removeListeners();
			
			var soundVO : SoundVO = new SoundVO();
			soundVO.sound = event.sound;
			soundVO.url = _fileReference.name;
			soundVO.isLoaded = true;
			
			facade.sendNotification(AppFacade.ADD_SOUND, soundVO);
		}

		/**
		 * 
		 */
		private function removeListeners() : void
		{
			_fileReference.removeEventListener(Event.SELECT, handleFileReferenceSelect);
			_mp3Loader.removeEventListener(MP3SoundEvent.COMPLETE, handleMp3LoaderComplete);
		}
	}
}
