package com.hisschemoller.view.components.base 
{
	import com.hisschemoller.view.components.base.Component;
	
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class Label extends Component 
	{
		protected var _autoSize : String = TextFieldAutoSize.LEFT;
		protected var _text : String = "";
		protected var _textField : TextField;

		public function Label(inAsset : MovieClip, inText : String = "")
		{
			_text = inText;
			
			super(null, inAsset);
		}

		/**
		 * Draws the visual ui of the component.
		 */
		override public function draw() : void
		{
			super.draw();
			
			_textField.text = _text;
			_textField.autoSize = _autoSize;
			
			_width = _textField.width;
			_height = _textField.height = 18;
		}

		/**
		 * Gets / sets the text of this Label.
		 */
		public function setText(inText : String) : void
		{
			_text = inText;
			invalidate();
		}

		public function getText() : String
		{
			return _text;
		}

		/**
		 * Gets / sets whether or not this Label will autosize.
		 */
		public function setAutoSize(inAutoSize : String) : void
		{
			_autoSize = inAutoSize;
		}

		public function getAutoSize() : String
		{
			return _autoSize;
		}

		/**
		 * Initializes the component.
		 */
		override protected function init() : void
		{
			super.init();
			
			_asset.mouseEnabled = false;
		}
	}
}
