﻿package yalog 
{
	import yalog.utils.debug.Log;
	import yalog.utils.debug.LogEvent;	
	/**
	 *	Copyright (c) 2007 Lost Boys 
	 *	@author stephan.bezoen
	 *	
	 */
	public class YaLogConnector 
	{
		private static var theInstance : YaLogConnector;

		/**
		 * @return singleton instance of YaLogConnector
		 */
		public static function getInstance() : YaLogConnector 
		{
			if (theInstance == null)
				theInstance = new YaLogConnector();
			return theInstance;
		}

		public function YaLogConnector() 
		{
			Log.addLogListener(handleLogEvent);
			Log.showTrace(false);
		}

		/**
		 *	
		 */
		private function handleLogEvent(e : LogEvent) : void 
		{
			trace("handleLogEvent ");
			
			switch (e.level) 
			{
				case Log.LEVEL_DEBUG: 
					Yalog.debug(e.text, e.sender); 
					break;
				case Log.LEVEL_ERROR: 
					Yalog.error(e.text, e.sender); 
					break;
				case Log.LEVEL_FATAL: 
					Yalog.fatal(e.text, e.sender); 
					break;
				case Log.LEVEL_INFO: 
					Yalog.info(e.text, e.sender); 
					break;
				case Log.LEVEL_STATUS: 
					Yalog.info(e.text, e.sender); 
					break;
				case Log.LEVEL_WARN: 
					Yalog.warn(e.text, e.sender); 
					break;
			}
		}

		/**
		 *	Connect to the Log
		 */
		public static function connect() : void 
		{
			YaLogConnector.getInstance();
		}
	}
}